
#include "Piles.h"
#include <stdlib.h>
#include <stdio.h>

/**
 * structure pour les noeuds de la pile. 
 * chaque noeud va contenir un element.
 */
struct _noeud
{
  struct _noeud * suivant;
  void * element;
};

typedef struct _noeud Noeud;

/** 
 * Structure d'entete de ma pile. 
 */
struct _pile
{
  Noeud * sommet;
  int taille;
};


Pile * creerPile( void )
{
  Pile * resultat = malloc( sizeof( Pile ) );

  ( * resultat ).sommet = NULL;
  ( * resultat ).taille = 0;

  return resultat;
}


int taillePile( Pile * a_pile )
{
  return ( * a_pile ).taille;
}


int estVidePile( Pile * a_pile )
{
  return ( * a_pile ).taille == 0;
}


void empilerPile( Pile * a_pile, void * a_element )
{
  Noeud * nouveauNoeud = malloc( sizeof( Noeud ) );
 
  ( * nouveauNoeud ).element = a_element;
  ( * nouveauNoeud ).suivant = ( * a_pile ).sommet;
  ++ ( ( * a_pile ).taille );
  ( * a_pile ).sommet = nouveauNoeud;
}


void * sommetPile( Pile * a_pile )
{
  return ( * ( ( * a_pile ).sommet ) ).element;
}


void depilerPile( Pile * a_pile )
{
  Noeud * noeud = ( * a_pile ).sommet;

  ( * a_pile ).sommet = ( * ( ( * a_pile ).sommet ) ).suivant;
  -- ( ( * a_pile ).taille );

  free( noeud );
}
